﻿﻿using UnityEngine;
using Random = System.Random;

public class BoilingOilControl : MonoBehaviour
{
    [SerializeField] float speed;
    [SerializeField] float minX;
    [SerializeField] Sprite[] liquid;
    int selectedLiquid;

    [SerializeField] AudioSource burstAudio;

    [SerializeField] GameObject[] bubbles;
    [SerializeField] GameObject Bubbles;

    readonly Random rand = new Random();
    [SerializeField] float speedAppearanceBubbles;

    void Start()
    {
        selectedLiquid = rand.Next(0, liquid.Length);
        foreach (Transform child in transform)
            child.GetComponent<SpriteRenderer>().sprite = liquid[selectedLiquid];
    }

    void FixedUpdate()
    {
        for (int i = 0; i < transform.childCount; i++)
        {
            Transform curChild = transform.GetChild(i);
            curChild.localPosition += Vector3.left * speed * Time.deltaTime;
        }
        if (transform.GetChild(0).localPosition.x < minX)
        {
            Transform child = transform.GetChild(0);
            child.localPosition =
                transform.GetChild(transform.childCount - 1).localPosition +
                Vector3.right * transform.GetChild(0).GetComponent<SpriteRenderer>().size.x;
            child.parent = transform.parent;
            child.parent = transform;
        }
    }

    void LateUpdate()
    {
        if (rand.NextDouble() < speedAppearanceBubbles)
        {
            GameObject bubble = Instantiate(bubbles[selectedLiquid], Bubbles.transform, true);
            bubble.transform.localPosition =
                new Vector3(((float) rand.NextDouble() - 0.5f) * 2 * CameraControl.SizeCamera.x,
                            -CameraControl.SizeCamera.y, 2);
        }
    }

    void OnTriggerEnter2D(Collider2D other)
    {
        if (other.CompareTag("Player")) burstAudio.Play();
    }
}