﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CreateBoxAroundCamera : MonoBehaviour
{
    [SerializeField] Camera mainCamera;
    [SerializeField] float padding;
    Vector2 sizeCamera;
    
    void Start()
    {
        transform.localPosition = new Vector2(0, 0);
        float orthographicSize = mainCamera.orthographicSize;
        sizeCamera = new Vector2(orthographicSize * Screen.width / Screen.height,
                                 orthographicSize);
        transform.localScale = new Vector2(sizeCamera.x, sizeCamera.y) * 2;

        float[] x = {-0.5f - padding, -0.5f, 0.5f, 0.5f + padding};
        float[] y = {-0.5f, 0.5f, 0.5f + padding};

        transform.GetComponent<PolygonCollider2D>().points = new[]
        {
            new Vector2(x[0], y[2]),
            new Vector2(x[0], y[0]),
            new Vector2(x[1], y[0]),
            new Vector2(x[1], y[1]),
            new Vector2(x[2], y[1]),
            new Vector2(x[2], y[0]),
            new Vector2(x[3], y[0]),
            new Vector2(x[3], y[2])
        };
    }
}
