﻿using System;
using DefaultNamespace;
using UnityEngine;

public class PlatformsControl : MonoBehaviour
{
    [SerializeField] Vector2[] vectors;
    [SerializeField] Vector2 paddingFoodOnPlatform;
    [SerializeField] GameObject[] platforms;
    [SerializeField] GameManager gameManager;
    [SerializeField] int minPlatforms, maxPlatforms;
    float minDistanceWidthPlatforms;

    [SerializeField] GameObject[] Foods;
    
    const int maxIteration = 15;
    readonly System.Random rand = new System.Random();

    void Start()
    {
        minDistanceWidthPlatforms = 200 * CameraControl.SizeCamera.x * 2 / Screen.width;
        Debug.Log(minDistanceWidthPlatforms);
    }
    
    public void CreateNewPlatforms(Vector2 futurePosCamera)
    {
        for (int i = transform.childCount; i < minPlatforms; i++)
            CreatePlatform(futurePosCamera, rand.Next(0, 3) < 2 ? Instantiate(Foods[rand.Next(0, Foods.Length)]) : null);
        if (transform.childCount < maxPlatforms)
            CreatePlatform(futurePosCamera, rand.Next(0, 3) < 2 ? Instantiate(Foods[rand.Next(0, Foods.Length)]) : null);
    }

    void CreatePlatform(Vector2 futurePosCamera, GameObject TopObject = null)
    {
        int randVector = rand.Next(0, vectors.Length);
        int i = 0;
        for(;!IsNormalPosition(futurePosCamera + vectors[randVector]) && i < maxIteration; i++)
            randVector = rand.Next(0, vectors.Length);
        if (i == maxIteration)
        {
            Destroy(TopObject);
            return;
        }
        GameObject plat = Instantiate(platforms[rand.Next(0, platforms.Length)], transform, true);
        plat.transform.position = futurePosCamera + vectors[randVector];
        plat.name = "platform";
        plat.GetComponent<PlatformController>().game = gameManager;

        if (TopObject == null) return;
        
        TopObject.transform.position = (Vector2)plat.transform.position + paddingFoodOnPlatform;
        TopObject.transform.parent = gameManager.Foods.transform;
        TopObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
    }

    bool IsNormalPosition(Vector2 pos)
    {
        for (int i = 0; i < transform.childCount; i++)
        {
            Transform child = transform.GetChild(i);
            if (Vector2.Distance(pos, child.position) < minDistanceWidthPlatforms)
                return false;
        }
        return true;
    }

    static float Distance(float a, float b) => Math.Abs(a - b);
}